#!/usr/bin/python
###########################################################################
#
# Copyright (C) Charles Shapiro 2006 charles.shapiro@tomshiro.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
# Enter a palette from the web.
# Use JavaScript color picker to figure out colors.
#
# $Id: enterPaletteFromWeb.py,v 1.5 2006/05/29 14:09:07 devel Exp $
#
###########################################################################
import cgi
import cgitb; cgitb.enable()
import os
import re
import ConfigParser

from filer import filer
from palette import A_Palette

#
# Main Line
#
print "Content-type: text/html\n"

config_reader=ConfigParser.ConfigParser()
config_reader.read("web.config")
save_dir=config_reader.get("PATHS","storagedir")
index_path=config_reader.get("PATHS","indexpath")

theForm=cgi.FieldStorage()
paletteDict={}
for kk in range(1,10):
	fname="digit"+str(kk)
	fldC=theForm.getfirst(fname)
	if fldC == None:
		paletteDict[kk]="White"
	else:
		paletteDict[kk]=fldC

the_palette=A_Palette(paletteDict)
fnPart=".palette"
my_filer=filer(save_dir,"*"+fnPart)
(last_filename,isdup)=my_filer.get_next_file(the_palette.get_hash())
if isdup == False:
	filename=os.path.join(save_dir,last_filename)
	the_palette.save_to_file(filename)
	my_filer.add_sum_to_listfile(the_palette.get_hash(),last_filename)
last_filenum=my_filer.num_from_fn(last_filename)
print "<html><body><h1>Your Palette is Saved.</h1>"
print "It is number <b> %d </b> Remember this.<br>" % (last_filenum)
print "Colors:<br>"
print "<table class=sudokutable id=sudokutable rules=none cellspacing=0 width=80% cellpadding=30 border=0  >"
print "<tr>"
tableSTr='<td width=11%% id=T0 bgcolor="%s">%d</td>'
for ii in range(1,10):
	print tableSTr % (the_palette.color_for_number(ii),ii)
print("</tr></table>")
print ("<hr>")
print "<a href=\"%s\">Back</a>" % (index_path)
print "</body></html>"