#!/usr/bin/python
##################################################################################
#
# Choose palette and sudoku, produce color map.
#
# $Id: grindSudokuFromWeb.py,v 1.5 2006/05/29 14:09:07 devel Exp $
#
##################################################################################
import cgi
import cgitb; cgitb.enable()
import sys
import os.path

import ConfigParser


from file_opter import file_options
from templategrinder import templateGrinder
from sudoku import A_Sudoku
from palette import A_Palette
from htmlGrinder import Html_Grinder

#
# Main Line 
#
myConfig=ConfigParser.ConfigParser()
myConfig.read("web.config")

grinder_dir=myConfig.get("PATHS","storagedir")
template_dir=myConfig.get("PATHS","templatedir")
html_dir=myConfig.get("PATHS","htmldir")

print "Content-type: text/html\n"

if 2 > len(sys.argv):
	template_dict={}
	my_opter=file_options(grinder_dir,"*.palette")
	template_dict["PaletteList"]=my_opter.get_option_list()
	my_opter.make_file_list(grinder_dir,"*.sudokuG")
	template_dict["SudokuList"]=my_opter.get_option_list()
	my_opter.set_before("Bad:")
	my_opter.make_file_list(grinder_dir,"*.sudokuB")
	template_dict["SudokuList"] += my_opter.get_option_list()
	my_opter.set_before("")
	my_opter.set_after("")
	my_opter.make_file_list(template_dir,"*.tpl")
	template_dict["TemplateList"]=my_opter.get_option_list()
	my_grinder=templateGrinder(template_dict,os.path.join(html_dir,"grind_sudoku.html"),1)
	print my_grinder.grind()
else:
	form_fields=cgi.FieldStorage()
	sudoku_name=form_fields.getfirst("Sudoku_FN")
	palette_name=form_fields.getfirst("Palette_FN")
	template_name=form_fields.getfirst("Template_FN")
	my_palette=A_Palette(palette_name,1)
	my_sudoku=A_Sudoku(sudoku_name,1)
	my_sudoku_grinder=Html_Grinder(my_sudoku,my_palette)
	my_sudoku_grinder.make_html(template_name)

	
